# mypy: disable_error_code = misc
import Boost.Python
import pxr.PxOsd
from typing import Any, ClassVar

class CapsuleMeshGenerator(Boost.Python.instance):
    minNumCapAxial: ClassVar[Any] = ...  # read-only
    minNumRadial: ClassVar[Any] = ...  # read-only
    def __init__(self, *args, **kwargs) -> None: ...
    @classmethod
    def ComputeNumPoints(cls, arg1: int, arg2: int, arg3: bool) -> int: ...
    @classmethod
    def GeneratePoints(cls, arg1: int, arg2: int, arg3: float, arg4: float) -> pxr.Vt.Vec3fArray: ...
    @classmethod
    def GenerateTopology(cls, arg1: int, arg2: int, arg3: bool) -> pxr.PxOsd.MeshTopology: ...
    def __reduce__(self) -> Any: ...

class ConeMeshGenerator(Boost.Python.instance):
    minNumRadial: ClassVar[Any] = ...  # read-only
    def __init__(self, *args, **kwargs) -> None: ...
    @classmethod
    def ComputeNumPoints(cls, arg1: int, arg2: bool) -> int: ...
    @classmethod
    def GeneratePoints(cls, arg1: int, arg2: float, arg3: float) -> pxr.Vt.Vec3fArray: ...
    @classmethod
    def GenerateTopology(cls, arg1: int, arg2: bool) -> pxr.PxOsd.MeshTopology: ...
    def __reduce__(self) -> Any: ...

class CuboidMeshGenerator(Boost.Python.instance):
    def __init__(self, *args, **kwargs) -> None: ...
    @classmethod
    def ComputeNumPoints(cls) -> int: ...
    @classmethod
    def GeneratePoints(cls, arg1: float, arg2: float, arg3: float) -> pxr.Vt.Vec3fArray: ...
    @classmethod
    def GenerateTopology(cls) -> pxr.PxOsd.MeshTopology: ...
    def __reduce__(self) -> Any: ...

class CylinderMeshGenerator(Boost.Python.instance):
    minNumRadial: ClassVar[Any] = ...  # read-only
    def __init__(self, *args, **kwargs) -> None: ...
    @classmethod
    def ComputeNumPoints(cls, arg1: int, arg2: bool) -> int: ...
    @classmethod
    def GeneratePoints(cls, arg1: int, arg2: float, arg3: float) -> pxr.Vt.Vec3fArray: ...
    @classmethod
    def GenerateTopology(cls, arg1: int, arg2: bool) -> pxr.PxOsd.MeshTopology: ...
    def __reduce__(self) -> Any: ...

class SphereMeshGenerator(Boost.Python.instance):
    minNumAxial: ClassVar[Any] = ...  # read-only
    minNumRadial: ClassVar[Any] = ...  # read-only
    def __init__(self, *args, **kwargs) -> None: ...
    @classmethod
    def ComputeNumPoints(cls, arg1: int, arg2: int, arg3: bool) -> int: ...
    @classmethod
    def GeneratePoints(cls, arg1: int, arg2: int, arg3: float) -> pxr.Vt.Vec3fArray: ...
    @classmethod
    def GenerateTopology(cls, arg1: int, arg2: int, arg3: bool) -> pxr.PxOsd.MeshTopology: ...
    def __reduce__(self) -> Any: ...