# mypy: disable_error_code = misc
import Boost.Python
import pxr.Ar
from typing import Any, ClassVar

class Registry(Boost.Python.instance):
    def __init__(self) -> None: ...
    @classmethod
    def GetAllKinds(cls) -> list[str]: ...
    @classmethod
    def GetBaseKind(cls, arg1: str | pxr.Ar.ResolvedPath) -> str: ...
    @classmethod
    def HasKind(cls, arg1: str | pxr.Ar.ResolvedPath) -> bool: ...
    @classmethod
    def IsA(cls, arg1: str | pxr.Ar.ResolvedPath, arg2: str | pxr.Ar.ResolvedPath) -> bool: ...
    def __bool__(self) -> bool: ...
    def __eq__(self, other: object) -> bool: ...
    def __lt__(self, other: object) -> bool: ...
    def __ne__(self, other: object) -> bool: ...
    def __reduce__(self) -> Any: ...
    @property
    def expired(self) -> Any: ...

class Tokens(Boost.Python.instance):
    assembly: ClassVar[Any] = ...  # read-only
    component: ClassVar[Any] = ...  # read-only
    group: ClassVar[Any] = ...  # read-only
    model: ClassVar[Any] = ...  # read-only
    subcomponent: ClassVar[Any] = ...  # read-only
    def __init__(self, *args, **kwargs) -> None: ...
    def __reduce__(self) -> Any: ...