# mypy: disable_error_code = misc
import Boost.Python
import pxr.Ndr
from typing import Any, ClassVar

class NodeContext(Boost.Python.instance):
    Displacement: ClassVar[Any] = ...  # read-only
    Light: ClassVar[Any] = ...  # read-only
    LightFilter: ClassVar[Any] = ...  # read-only
    Pattern: ClassVar[Any] = ...  # read-only
    PixelFilter: ClassVar[Any] = ...  # read-only
    SampleFilter: ClassVar[Any] = ...  # read-only
    Surface: ClassVar[Any] = ...  # read-only
    Volume: ClassVar[Any] = ...  # read-only
    def __init__(self, *args, **kwargs) -> None: ...
    def __reduce__(self) -> Any: ...

class NodeMetadata(Boost.Python.instance):
    Category: ClassVar[Any] = ...  # read-only
    Departments: ClassVar[Any] = ...  # read-only
    Help: ClassVar[Any] = ...  # read-only
    ImplementationName: ClassVar[Any] = ...  # read-only
    Label: ClassVar[Any] = ...  # read-only
    Pages: ClassVar[Any] = ...  # read-only
    Primvars: ClassVar[Any] = ...  # read-only
    Role: ClassVar[Any] = ...  # read-only
    SdrDefinitionNameFallbackPrefix: ClassVar[Any] = ...  # read-only
    SdrUsdEncodingVersion: ClassVar[Any] = ...  # read-only
    Target: ClassVar[Any] = ...  # read-only
    def __init__(self, *args, **kwargs) -> None: ...
    def __reduce__(self) -> Any: ...

class NodeRole(Boost.Python.instance):
    Field: ClassVar[Any] = ...  # read-only
    Math: ClassVar[Any] = ...  # read-only
    Primvar: ClassVar[Any] = ...  # read-only
    Texture: ClassVar[Any] = ...  # read-only
    def __init__(self, *args, **kwargs) -> None: ...
    def __reduce__(self) -> Any: ...

class PropertyMetadata(Boost.Python.instance):
    Colorspace: ClassVar[Any] = ...  # read-only
    Connectable: ClassVar[Any] = ...  # read-only
    DefaultInput: ClassVar[Any] = ...  # read-only
    Help: ClassVar[Any] = ...  # read-only
    Hints: ClassVar[Any] = ...  # read-only
    ImplementationName: ClassVar[Any] = ...  # read-only
    IsAssetIdentifier: ClassVar[Any] = ...  # read-only
    IsDynamicArray: ClassVar[Any] = ...  # read-only
    Label: ClassVar[Any] = ...  # read-only
    Options: ClassVar[Any] = ...  # read-only
    Page: ClassVar[Any] = ...  # read-only
    RenderType: ClassVar[Any] = ...  # read-only
    Role: ClassVar[Any] = ...  # read-only
    SdrUsdDefinitionType: ClassVar[Any] = ...  # read-only
    Tag: ClassVar[Any] = ...  # read-only
    Target: ClassVar[Any] = ...  # read-only
    ValidConnectionTypes: ClassVar[Any] = ...  # read-only
    VstructConditionalExpr: ClassVar[Any] = ...  # read-only
    VstructMemberName: ClassVar[Any] = ...  # read-only
    VstructMemberOf: ClassVar[Any] = ...  # read-only
    Widget: ClassVar[Any] = ...  # read-only
    def __init__(self, *args, **kwargs) -> None: ...
    def __reduce__(self) -> Any: ...

class PropertyRole(Boost.Python.instance):
    def __init__(self, *args, **kwargs) -> None: ...
    def __reduce__(self) -> Any: ...

class PropertyTypes(Boost.Python.instance):
    Color: ClassVar[Any] = ...  # read-only
    Color4: ClassVar[Any] = ...  # read-only
    Float: ClassVar[Any] = ...  # read-only
    Int: ClassVar[Any] = ...  # read-only
    Matrix: ClassVar[Any] = ...  # read-only
    Normal: ClassVar[Any] = ...  # read-only
    Point: ClassVar[Any] = ...  # read-only
    String: ClassVar[Any] = ...  # read-only
    Struct: ClassVar[Any] = ...  # read-only
    Terminal: ClassVar[Any] = ...  # read-only
    Unknown: ClassVar[Any] = ...  # read-only
    Vector: ClassVar[Any] = ...  # read-only
    Vstruct: ClassVar[Any] = ...  # read-only
    def __init__(self, *args, **kwargs) -> None: ...
    def __reduce__(self) -> Any: ...

class Registry(pxr.Ndr.Registry):
    def __init__(self) -> None: ...
    def GetShaderNodeByIdentifier(self, identifier: str | pxr.Ar.ResolvedPath, typePriority: list[str] | list[pxr.Ar.ResolvedPath] = ...) -> ShaderNode: ...
    def GetShaderNodeByIdentifierAndType(self, identifier: str | pxr.Ar.ResolvedPath, nodeType: str | pxr.Ar.ResolvedPath) -> ShaderNode: ...
    def GetShaderNodeByName(self, name: str | pxr.Ar.ResolvedPath, typePriority: list[str] | list[pxr.Ar.ResolvedPath] = ..., filter: pxr.Ndr.VersionFilter = ...) -> ShaderNode: ...
    def GetShaderNodeByNameAndType(self, name: str | pxr.Ar.ResolvedPath, nodeType: str | pxr.Ar.ResolvedPath, filter: pxr.Ndr.VersionFilter = ...) -> ShaderNode: ...
    def GetShaderNodeFromAsset(self, shaderAsset: pxr.Sdf.AssetPath | str, metadata: dict[str | pxr.Ar.ResolvedPath, str | pxr.Ar.ResolvedPath] = ..., subIdentifier: str | pxr.Ar.ResolvedPath = ..., sourceType: str | pxr.Ar.ResolvedPath = ...) -> ShaderNode: ...
    def GetShaderNodeFromSourceCode(self, sourceCode: str | pxr.Ar.ResolvedPath, sourceType: str | pxr.Ar.ResolvedPath, metadata: dict[str | pxr.Ar.ResolvedPath, str | pxr.Ar.ResolvedPath] = ...) -> ShaderNode: ...
    def GetShaderNodesByFamily(self, family: str | pxr.Ar.ResolvedPath = ..., filter: pxr.Ndr.VersionFilter = ...) -> ShaderNodeList: ...
    def GetShaderNodesByIdentifier(self, identifier: str | pxr.Ar.ResolvedPath) -> ShaderNodeList: ...
    def GetShaderNodesByName(self, name: str | pxr.Ar.ResolvedPath, filter: pxr.Ndr.VersionFilter = ...) -> ShaderNodeList: ...
    def __bool__(self) -> bool: ...
    def __eq__(self, other: object) -> bool: ...
    def __lt__(self, other: object) -> bool: ...
    def __ne__(self, other: object) -> bool: ...
    def __reduce__(self) -> Any: ...
    @property
    def expired(self) -> Any: ...

class ShaderNode(pxr.Ndr.Node):
    def __init__(self, *args, **kwargs) -> None: ...
    def GetAdditionalPrimvarProperties(self) -> list[str]: ...
    def GetAllVstructNames(self) -> list[str]: ...
    def GetAssetIdentifierInputNames(self) -> list[str]: ...
    def GetCategory(self) -> str: ...
    def GetDefaultInput(self) -> ShaderProperty: ...
    def GetDepartments(self) -> list[str]: ...
    def GetHelp(self) -> str: ...
    def GetImplementationName(self) -> str: ...
    def GetLabel(self) -> str: ...
    def GetPages(self) -> list[str]: ...
    def GetPrimvars(self) -> list[str]: ...
    def GetPropertyNamesForPage(self, arg2: str | pxr.Ar.ResolvedPath) -> list[str]: ...
    def GetRole(self) -> str: ...
    def GetShaderInput(self, arg2: str | pxr.Ar.ResolvedPath) -> ShaderProperty: ...
    def GetShaderOutput(self, arg2: str | pxr.Ar.ResolvedPath) -> ShaderProperty: ...
    def __reduce__(self) -> Any: ...

class ShaderNodeList(Boost.Python.instance):
    __instance_size__: ClassVar[int] = ...
    def __init__(self) -> None: ...
    def append(self, arg2: object) -> None: ...
    def extend(self, arg2: object) -> None: ...
    def __contains__(self, arg2: object) -> bool: ...
    def __delitem__(self, arg2: object) -> None: ...
    def __getitem__(self, arg2: object) -> Any: ...
    def __iter__(self) -> Any: ...
    def __len__(self) -> int: ...
    def __reduce__(self) -> Any: ...
    def __setitem__(self, arg2: object, arg3: object) -> None: ...

class ShaderProperty(pxr.Ndr.Property):
    def __init__(self, *args, **kwargs) -> None: ...
    def GetDefaultValueAsSdfType(self) -> Any: ...
    def GetHelp(self) -> str: ...
    def GetHints(self) -> dict: ...
    def GetImplementationName(self) -> str: ...
    def GetLabel(self) -> str: ...
    def GetOptions(self) -> list: ...
    def GetPage(self) -> str: ...
    def GetVStructConditionalExpr(self) -> str: ...
    def GetVStructMemberName(self) -> str: ...
    def GetVStructMemberOf(self) -> str: ...
    def GetValidConnectionTypes(self) -> list[str]: ...
    def GetWidget(self) -> str: ...
    def IsAssetIdentifier(self) -> bool: ...
    def IsDefaultInput(self) -> bool: ...
    def IsVStruct(self) -> bool: ...
    def IsVStructMember(self) -> bool: ...
    def __reduce__(self) -> Any: ...