# mypy: disable_error_code = misc
import Boost.Python
import pxr.Ar
from . import cameraArgs as cameraArgs, colorArgs as colorArgs, complexityArgs as complexityArgs, framesArgs as framesArgs, rendererArgs as rendererArgs
from typing import Any, ClassVar, overload

class FrameRecorder(Boost.Python.instance):
    __instance_size__: ClassVar[int] = ...
    @overload
    def __init__(self, arg2: object, arg3: bool) -> None: ...
    @overload
    def __init__(self) -> None: ...
    def GetCurrentRendererId(self) -> str: ...
    def Record(self, stage: pxr.Usd.Stage, usdCamera: pxr.UsdGeom.Camera, timeCode: pxr.Usd.TimeCode | float | pxr.Sdf.TimeCode, outputImagePath: str | pxr.Ar.ResolvedPath) -> bool: ...
    def SetColorCorrectionMode(self, arg2: str | pxr.Ar.ResolvedPath) -> None: ...
    def SetComplexity(self, arg2: float) -> None: ...
    def SetImageWidth(self, arg2: int) -> None: ...
    def SetIncludedPurposes(self, purposes: list[str] | list[pxr.Ar.ResolvedPath]) -> None: ...
    def SetRendererPlugin(self, arg2: str | pxr.Ar.ResolvedPath) -> bool: ...
    def __reduce__(self) -> Any: ...

def GetCameraAtPath(stage: pxr.Usd.Stage, cameraPath: pxr.Sdf.Path | str) -> pxr.UsdGeom.Camera: ...