# mypy: disable_error_code = misc
import Boost.Python
import pxr.Usd
import typing
import typing_extensions
from typing import Any, ClassVar, overload

class Complex(Simple):
    __instance_size__: ClassVar[int] = ...
    @overload
    def __init__(self, prim: pxr.Usd.Prim) -> None: ...
    @overload
    def __init__(self, schemaObj: pxr.Usd.SchemaBase) -> None: ...
    @overload
    def __init__(self) -> None: ...
    def CreateComplexStringAttr(self, defaultValue: object = ..., writeSparsely: bool = ...) -> pxr.Usd.Attribute: ...
    def Define(self, stage: pxr.Usd.Stage, path: pxr.Sdf.Path | str) -> typing_extensions.Self: ...
    def Get(self, stage: pxr.Usd.Stage, path: pxr.Sdf.Path | str) -> typing_extensions.Self: ...
    def GetComplexStringAttr(self) -> pxr.Usd.Attribute: ...
    def GetSchemaAttributeNames(self, includeInherited: bool = ...) -> list: ...
    def _GetStaticTfType(self) -> pxr.Tf.Type: ...
    def __bool__(self) -> bool: ...
    def __reduce__(self) -> Any: ...

class ParamsAPI(pxr.Usd.APISchemaBase):
    __instance_size__: ClassVar[int] = ...
    @overload
    def __init__(self, prim: pxr.Usd.Prim) -> None: ...
    @overload
    def __init__(self, schemaObj: pxr.Usd.SchemaBase) -> None: ...
    @overload
    def __init__(self) -> None: ...
    def Apply(self, prim: pxr.Usd.Prim) -> typing_extensions.Self: ...
    def CanApply(self, prim: pxr.Usd.Prim) -> _CanApplyResult: ...
    def CreateMassAttr(self, defaultValue: object = ..., writeSparsely: bool = ...) -> pxr.Usd.Attribute: ...
    def CreateVelocityAttr(self, defaultValue: object = ..., writeSparsely: bool = ...) -> pxr.Usd.Attribute: ...
    def CreateVolumeAttr(self, defaultValue: object = ..., writeSparsely: bool = ...) -> pxr.Usd.Attribute: ...
    def Get(self, stage: pxr.Usd.Stage, path: pxr.Sdf.Path | str) -> typing_extensions.Self: ...
    def GetMassAttr(self) -> pxr.Usd.Attribute: ...
    def GetSchemaAttributeNames(self, includeInherited: bool = ...) -> list: ...
    def GetVelocityAttr(self) -> pxr.Usd.Attribute: ...
    def GetVolumeAttr(self) -> pxr.Usd.Attribute: ...
    def _GetStaticTfType(self) -> pxr.Tf.Type: ...
    def __bool__(self) -> bool: ...
    def __reduce__(self) -> Any: ...

class Simple(pxr.Usd.Typed):
    __instance_size__: ClassVar[int] = ...
    @overload
    def __init__(self, prim: pxr.Usd.Prim) -> None: ...
    @overload
    def __init__(self, schemaObj: pxr.Usd.SchemaBase) -> None: ...
    @overload
    def __init__(self) -> None: ...
    def CreateIntAttrAttr(self, defaultValue: object = ..., writeSparsely: bool = ...) -> pxr.Usd.Attribute: ...
    def CreateTargetRel(self) -> pxr.Usd.Relationship: ...
    def Get(self, stage: pxr.Usd.Stage, path: pxr.Sdf.Path | str) -> typing_extensions.Self: ...
    def GetIntAttrAttr(self) -> pxr.Usd.Attribute: ...
    def GetSchemaAttributeNames(self, includeInherited: bool = ...) -> list: ...
    def GetTargetRel(self) -> pxr.Usd.Relationship: ...
    def _GetStaticTfType(self) -> pxr.Tf.Type: ...
    def __bool__(self) -> bool: ...
    def __reduce__(self) -> Any: ...

class Tokens(Boost.Python.instance):
    ComplexPrim: ClassVar[Any] = ...  # read-only
    ParamsAPI: ClassVar[Any] = ...  # read-only
    SimplePrim: ClassVar[Any] = ...  # read-only
    complexString: ClassVar[Any] = ...  # read-only
    intAttr: ClassVar[Any] = ...  # read-only
    paramsMass: ClassVar[Any] = ...  # read-only
    paramsVelocity: ClassVar[Any] = ...  # read-only
    paramsVolume: ClassVar[Any] = ...  # read-only
    target: ClassVar[Any] = ...  # read-only
    def __init__(self, *args, **kwargs) -> None: ...
    def __reduce__(self) -> Any: ...

class _CanApplyResult(Boost.Python.instance):
    __instance_size__: ClassVar[int] = ...
    def __init__(self, arg2: bool, arg3: object) -> None: ...
    def __bool__(self) -> bool: ...
    def __eq__(self, other: object) -> bool: ...
    def __getitem__(self, arg2: int) -> Any: ...
    def __iter__(self) -> typing.Iterator[Any]: ...
    def __ne__(self, other: object) -> bool: ...
    def __reduce__(self) -> Any: ...
    @property
    def whyNot(self) -> Any: ...