# mypy: disable_error_code = misc
import pxr.Plug as Plug
import pxr.Tf as Tf
from _typeshed import Incomplete
from pxr.Tf import PluginContainerTfType as PluginContainerTfType
from typing import Any

class CommandPlugin:
    def __init__(self, name, displayName, callback, description, usdviewApi): ...
    def run(self): ...
    @property
    def description(self) -> Any: ...
    @property
    def displayName(self) -> Any: ...
    @property
    def name(self) -> Any: ...

class DeferredImport:
    def __init__(self, moduleName, packageName: Incomplete | None = ...): ...
    def __getattr__(self, attr): ...

class DuplicateCommandPlugin(Exception):
    def __init__(self, name): ...

class PluginContainer:
    def configureView(self, plugRegistry, plugUIBuilder): ...
    def deferredImport(self, moduleName): ...
    def registerPlugins(self, plugRegistry, plugCtx): ...

class PluginMenu:
    def __init__(self, qMenu): ...
    def addItem(self, commandPlugin, shortcut: Incomplete | None = ...): ...
    def addSeparator(self): ...
    def findOrCreateSubmenu(self, menuName): ...

class PluginRegistry:
    def __init__(self, usdviewApi): ...
    def getCommandPlugin(self, name): ...
    def registerCommandPlugin(self, name, displayName, callback, description: str = ...): ...

class PluginUIBuilder:
    def __init__(self, mainWindow): ...
    def findOrCreateMenu(self, menuName): ...

def loadPlugins(usdviewApi, mainWindow): ...